<?php
/**
 * @package     PHP-Bridge
 * @subpackage  com_phpbridge
 *
 * @copyright   Copyright (C) 2017 Henry Schorradt, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

// No direct access to this file
defined('_JEXEC') or die('Restricted access');


/**
 * PHPBridge View
 */
class PhpBridgeViewPhpBridge extends JViewLegacy
{

    /**
     * @var  object
     */
    protected $item;

    /**
     * @var  JObject
     */
    protected $state;

    /**
     * @var  JObject
     */
    protected $canDo;

    /**
     *  view display method
     * @param null $tpl
     * @return void
     * @throws Exception
     */
    public function display($tpl = null)
    {
        $user = JFactory::getUser();

        $this->item    = $this->get('Item');
        $this->state   = $this->get('State');

        $this->canDo = JHelperContent::getActions('com_phpbridge', 'menu', (int) $this->state->get('item.menutypeid'));

        // Check if we're allowed to edit this item
        // No need to check for create, because then the moduletype select is empty
        if (!empty($this->item->id) && !$this->canDo->get('core.edit')) {
            throw new Exception(JText::_('JERROR_ALERTNOAUTHOR'), 403);
        }

        // Check for errors.
        if (count($errors = $this->get('Errors'))) {
            JFactory::getApplication()->enqueueMessage(implode("\n", $errors), 'error');
        }

        // Set the toolbar
        $this->addToolBar();

        // Set the document
        $this->setDocument();


        // Display the template
        parent::display($tpl);

    }

    /**
     * Setting the toolbar
     */
    protected function addToolBar()
    {
        JToolBarHelper::title(JText::_('COM_PHPBRIDGE'), 'phpbridge');
        JToolBarHelper::preferences('com_phpbridge');
    }

    /**
     * Method to set up the document properties
     *
     * @return void
     */
    protected function setDocument()
    {
        $document = JFactory::getDocument();
        $document->setTitle(JText::_('COM_PHPBRIDGE_CONFIGURATION'));
        $document->addStyleSheet(JURI::root(true) . '/media/com_phpbridge/css/admin.styles.css');
    }
}
